#include "TrafficSignal.h"

// le constructeur

TrafficSignal::TrafficSignal()
{
}

// La methode du setup

void TrafficSignal::Setup(int Signal2, int Signal3,int DccID, int ledStatusPin, int buttonPin)
{
   // les attributs

    int DccBegin = 0;

    // Les bibliotheques

    Commanders::begin(ledStatusPin);
    Accessories::begin();

    // initialisation du DCC

    DccCommander.begin(0x00, 0x00, KDCC_INTERRUPT, true);

	// Creation du bouton de test, une action par Led

    button.begin(0, buttonPin);
    for (int i = 0; i < Signal2; i++)
    {
        button.AddEvent(DCCINT(DccID + i, 0));		// vert  DCC/0
        button.AddEvent(DCCINT(DccID + i, 1));		// rouge DCC/1
    }

    DccBegin = Signal2;
    for (int i = Signal2; i < Signal2 + Signal3; i++)
    {
        button.AddEvent(DCCINT(DccID + DccBegin, 0));	// vert  DCC/0
        button.AddEvent(DCCINT(DccID + DccBegin, 1));	// rouge DCC/1
        button.AddEvent(DCCINT(DccID + DccBegin+1, 0));	// jaune DCC+1/0
        DccBegin = DccBegin + 2;
    }

    int ledPin = 3;
	DccBegin = DccID;
	leds = new AccessoryLightMulti[Signal2 + Signal3];

	// Creation des ports et des accessoires associes

    for (int i = 0; i < Signal2; i++) 
    {
        leds[i].begin(2000 + i, 2, 0);

		PortOnePin *pPort0 = new PortOnePin();
		pPort0->begin(ledPin++, DIGITAL);
		PortOnePin *pPort1 = new PortOnePin();
		pPort1->begin(ledPin++, DIGITAL);

        leds[i].beginLight(0, pPort0);	// vert
        leds[i].beginLight(1, pPort1);	// rouge

        leds[i].AddMovingPosition(DCCINT(DccBegin, 0), 0b01, 0);
        leds[i].AddMovingPosition(DCCINT(DccBegin++, 1), 0b10, 0);
	}

    for (int i = Signal2; i < Signal2 + Signal3; i++) 
    {
        leds[i].begin(3000 + i, 3, 0);

        PortOnePin *pPort0 = new PortOnePin();
		pPort0->begin(ledPin++, DIGITAL);
		PortOnePin *pPort1 = new PortOnePin();
		pPort1->begin(ledPin++, DIGITAL);
		PortOnePin *pPort2 = new PortOnePin();
		pPort2->begin(ledPin++, DIGITAL);

		leds[i].beginLight(0, pPort0);   // vert
        leds[i].beginLight(1, pPort1);   // rouge
        leds[i].beginLight(2, pPort2);   // jaune

        leds[i].AddMovingPosition(DCCINT(DccBegin, 0), 0b001, 0);
        leds[i].AddMovingPosition(DCCINT(DccBegin++, 1), 0b010, 0);
        leds[i].AddMovingPosition(DCCINT(DccBegin++, 0), 0b100, 0);
	}

	// Initialisation de tous les signaux a la premiere position (0)
	for (int i = 0; i < Signal2 + Signal3; i++)
		leds[i].Event(leds[i].GetMovingPositionIdByIndex(0));

	//Commanders::printCommanders();
	//Accessories::printAccessories();
}

void TrafficSignal::loop()
{
	unsigned long id = Commanders::loop();

	if (id != UNDEFINED_ID)
	{
		// Renvoie l'evenement recu de Commanders, vers les accessoires...
		Accessories::RaiseEvent(id, (ACCESSORIES_EVENT_TYPE) Commanders::GetLastEventType(), Commanders::GetLastEventData());
	}

	Accessories::loop();
}
